{Codepage utf8}
Uses Listas,sysutils,math;  

Procedure OrdenarA(A:LPalabras);    
Var i,j:longint;
      aux:Unicodestring;    
      intv:longword;       
 Begin     
     intv:=length(A) div 2;
     While intv>0 do   
       Begin
          for i:=intv to high(A) do 
             Begin
                j:=i-intv;        
                aux:=A[i]; 
                while ((j>=0) and (aux<A[j])) do 
                   Begin
                      A[j+intv]:=A[j];
                      j:=j-intv
                   End;
                 A[j+intv]:=aux                   
             End;
           intv:=intv div 2  
       End;
 End;     
 
Procedure OrdenarB(A:LPalabras);    
Var i,j:longword;
      aux:Unicodestring;    
      intv:longword;     
      IniLista:Boolean;  
 Begin     
     intv:=length(A) div 2;
     While intv>0 do 
       Begin
          for i:=intv to high(A) do
             Begin
                j:=i-intv;        
                aux:=A[i];    
                IniLista:=false;                
                while (not IniLista) and (aux<A[j]) do 
                   Begin
                      A[j+intv]:=A[j];
                      if j>=intv then j:=j-intv else IniLista:=true
                   End;                 
                 if IniLista then A[j]:=aux  
                                 else A[j+intv]:=aux                  
             End;
           intv:=intv div 2 
       End;
 End;     

Procedure OrdenarC(A:LPalabras);    
Var i,j:longint;
      aux:Unicodestring;    
      intv:longword;       
 Begin     
     intv:=(length(A)*5) div 11;          
     While intv>0 do   
       Begin          
          for i:=intv to high(A) do 
             Begin
                j:=i;       
                aux:=A[i];                   
                while ((j>=intv) and (aux<A[j-intv])) do 
                   Begin
                      A[j]:=A[j-intv];     
                      j:=j-intv                 
                   End;
                 A[j]:=aux  
             End;                        
           intv:=(intv * 5) div 11 ;            
           if intv=2 then intv:=1
       End;
 End;     
 
Procedure OrdenarD(A:LPalabras);    
Var i,j:longint;
      aux:Unicodestring;    
      intv:longword;       
      n:longword;
 Begin     
     intv:=0;
     if length(A)>1 then
       Begin
        n:=trunc(ln(length(A)-1)+2);
        intv:=trunc((1+exp(n-2))+0.5); 
       End;     
     While intv>0 do  
       Begin
          for i:=intv to high(A) do 
             Begin
                j:=i;        
                aux:=A[i];
                while ((j>=intv) and (aux<A[j-intv])) do 
                   Begin
                      A[j]:=A[j-intv];    
                      j:=j-intv                 
                   End;
                 A[j]:=aux  
             End;
           n-=1;
           if n>0 then intv:=trunc((1+exp(n-2))+0.5)
                      else intv:=0           
       End;
 End;         
 
Var A,B,C,D:LPalabras; 
      t1,t2:double;              
      i:longint;
Begin 
   SetLength(A,100000);   
   SetLength(B,100000);   
   SetLength(C,100000);      
   SetLength(D,100000);

   ListaAleatoria(A,25); 

   for i:=0 to high(A) do Begin B[i]:=A[i]; C[i]:=A[i]; D[i]:=A[i] End; 

  Write('A-->  ');   
   t1:=time;
   OrdenarA(A);    
   t2:=time;
   Writeln(FormatDateTime('hh:nn:ss:z',t2-t1));       

   Write('B-->  ');   
   t1:=time;
   OrdenarB(B);    
   t2:=time;
   Writeln(FormatDateTime('hh:nn:ss:z',t2-t1));

   Write('C-->  ');
   t1:=time;
   OrdenarC(C);
   t2:=time;
   Writeln(FormatDateTime('hh:nn:ss:z',t2-t1));

   Write('D-->  ');
   t1:=time;
   OrdenarD(D);
   t2:=time;
   Writeln(FormatDateTime('hh:nn:ss:z',t2-t1))
   
End.
